;****************    +  +   ATmega 8  ***************
;*
;*     WH1601A
;*   DS1624
;*   MPX4115
;*    PCF8583
;*     TWI = 100Hz
;*    ADC = 125Hz
;*   AVR - ATmega8 = 8MHz
;*   ADC0
;* :
;* InitLCD:    -  8- 
;* InitDS:     DS1624 
;* HexBCD:         
;* XBruchD:        
;* OutText:      LCD
;* ConvDS:        DS1624,    
;* ConvDSExt:     DS1624,   
;* CalcPress:      
;* PressLCD:      LCD
;* Main:       
;* OutWH2,3,4,5:   LCD  , ,  ,  
;* OutWHcur:     PCF8583  LCD   
;* OutWHCM:         LCD
;* OutWHAL:         LCD
;* OutWHCTim:     PCF8583  LCD
;* OutWHCTim2:    
;* OutWHITim:       PCF8583
;* OutWHTim:      PCF8583 ( )
;* OutWH1:           PCF8583  LCD
;* OutWHW:          
;* OutWHBM:           
;* OutWHSCT:     PCF8583
;* OutWHTWork:    
;* OutWHWar:     PCF8583   
;* OutWHDS:        
;* OutWHDSExt:      
;* ChoiceDS:     ,  
;* ChoiceDSExt:    ,  
;* ReadPCFS:    Status PCF8583
;* ReadPCFC:    Alarm Control PCF8583
;* ReadPCFA:    AL_Timer PCF8583
;* ReadPCFSec:   Seconds PCF8583
;* ReadPCFSCT:    PCF8583
;* ReadPCFW:       PCF8583
;* ReadTim:      PCF8583
;* ReadPCF1:         PCF8583
;* ReadPCFcur:     PCF8583   
;* LoadTimer1:   1,    
;* StopTim;   /      
;* TimStart:  /      PCF8583
;* InsTimer:  /   PCF8583
;* ReadStat:  /      PCF8583
;* Currtime:  /      
;* WritePCF:     PCF8583
;* ALARM:     /   
;* ALARMTimer: /   
;* InsClock:   
;* Check:         PCF8583
;* Monitor:      
;* Timer_Int: /     ( )
;* Timer_Int2:/     (  PCF8583)
;*  : 0b1101100111101111
;***************************************************************************

.nolist
.include "m8def.inc"
.list
;*****  *****

.def  m0 = r0       ;  /   
.def  m1 = r1
.def  m2 = r2
.def  m3 = r3
.def  m4 = r4
.def  m5 = r5
.def  m6 = r6
.def  m7 = r7
.def  Sanct = r8    ;      
.def  Save = r9     ;   SREG  
.def  Stime = r10   ;      
.def  tim3 = r11	;   3           
.def  hexH = r12    ;     hex (  hex)
.def  hexL = r13    ;     hex (  hex)
.def  cpyL = r14    ;  
.def  sum = r15     ;   ,   
.def  I1 =  r16     ;    
.def  tmp1 = r17	;   1
.def  tmp2 = r18	;   2
.def  prm1 = r19	;  
.def  tim1 = r20	;   1
.def  tim2 = r21	;   2
.def  Cnt  = r22	;  
.def  BCD0 = r23    ;  2  1    LCD
.def  BCD1 = r24    ;  4  3    LCD
.def  BCD2 = r25    ;     BCD-
            ;XL     ;      ,                

;*****   *****

.equ  RAM  =$0060
.equ  ADSM = 0b10001110  ; ADEN,ADIE,ADPS2,ADPS1=1
.equ  ADMX = 0b01000000  ; RES0=1,MUX=0
.equ  RS   = 1	         ; Register Select =  1  C
.equ  RW   = 2	         ; R/W =  2  C (/WR)
.equ  Ena  = 3    	     ; Enable Impuls =  3  C
.equ  SDA  = 4           ;  TWI
.equ  SCL  = 5           ;  TWI
.equ  BF   = 7	         ;   =  7  D
.equ  TimeH = 241        ;      1  
.equ  TimeL = 0          ;     
.equ  Time1H = 104       ;      1  
.equ  Time1L = 0         ;   , 5 

.cseg

.org 0

rjmp  Initial	       ;       

.org 4                 ;   /    T2,    RTC
rjmp Timer_Int2

.org 6                 ;   /    T1,  
rcall LoadTimer1       ;   1
reti

.org 8                 ;   /    T1,  
rjmp Timer_Int1

.org  ADCCaddr           ;    ADC Complete
ldi   I1,0b00010000      ; SE=0 ( "" ), SM[2..0]=001
out   MCUCR,I1           ; ""  =  
reti

Initial:

ldi   tmp1,High(RamEnd) 
out   sph,tmp1
ldi   tmp1,Low(RamEnd)
out   spl,tmp1	   ;  
clr   tmp1	       ;  tmp1 
out   PortC,tmp1   ; Res,SCL,SDA,/RD,/WR,Ena,RS,=0 
out   DDRB,tmp1	   ;    
ldi   tmp1,$0E	   ;  3,2,1, = 1
out   DDRC,tmp1	   ;  3,2,1, - ,  - 
ser   tmp1	       ;  tmp1
out   DDRD,tmp1	   ;  D - 
out   PortB,tmp1   ;    - ,  
ldi   tmp1,5	   ;  
out   TCCR0,tmp1   ;  T/C0,  . = 1024
ldi   tmp1,5	   ;  
out   TCCR1B,tmp1  ;  T/C1,  . = 1024
ldi   tmp1,$20 
out   TWBR,tmp1    ;     TWI (100kHz)
ldi   tmp1,$1E     
mov   Stime,tmp1   ;    
ldi   tmp1,55      ;     A,B,C,D,E,F
mov   sum,tmp1     ;    
rcall InitLCD      ;   
rcall OutWH2       ;   LCD  
rcall OutWH3       ;   LCD 
rcall OutWH4       ;   LCD    
ldi r29,$A0        ;   
ldi r28,0            
ldi r27,$0D            
rcall WritePCF 
rcall ReadPCFS     ;   PCF8583      
rcall ReadPCFC     ;   PCF8583      
rcall ChoiceDS     ;    
rcall ChoiceDSExt  ;    ,  
ldi tmp1,1
mov m1,tmp1           ;  EEPROM
rcall EERead          ;   EEPROM   
sts SV10,tmp1         ;   
ldi tmp1,2
mov m1,tmp1           ;  EEPROM
rcall EERead          ;   EEPROM   
sts SV11,tmp1         ;   
ldi  tmp1,Time1H      ;    1    
out  TCNT1H,tmp1      ;     
ldi  tmp1,Time1L 
out  TCNT1L,tmp1
ldi tmp1,$FF
out OCR1AH,tmp1       ;    1 
out OCR1AL,tmp1
ldi tmp1,(1<<OCIE1A)  
out TIMSK,tmp1
clr XL
sts SV8,XL
clr Sanct
ldi	tmp1,(1<<WDTOE)|(1<<WDE)
out	WDTCR,tmp1			;  
ldi	tmp1,(1<<WDE)|(1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
out	WDTCR,tmp1		; :   
					;  (wdr)   2,0 
					;    
					; RESET
sei                   ;   

Main:

wdr
clr  tmp1
in  tmp1,PINB          ;    SB1
sbrs tmp1,0            ;   ,    1
rjmp InsClock          ;    
clr  tmp1
in  tmp1,PINB          ;    SB3
sbrs tmp1,2            ;   ,    1
rcall Currtime         ;     
clr  tmp1
in  tmp1,PINB          ;    SB4
sbrs tmp1,3            ;   ,    1
rcall ReadStat         ;       PCF8583 
clr  tmp1
in  tmp1,PINB          ;    SB5
sbrs tmp1,4            ;   ,    1
rjmp InsTimer          ;      PCF8583
clr  tmp1
in  tmp1,PINB          ;   
sbrs tmp1,1            ;   ,    1
rjmp Check             ;      
cpi XL,0               ;     
breq CI0               ;     XL
cpi XL,1
breq CI1
cpi XL,2
breq CI2
cpi XL,3
breq CI3
CI0:
rcall ReadPCFW         ;     PCF8583
rcall  ReadPCFcur      ;   
sbrs Sanct,0           ;    
rcall  OutWHcur        ;     LCD
rjmp Main
CI1:
rcall  ConvDS          ;     DS1624
sbrs Sanct,1           ;    
rcall  OutWHDS         ;      
rjmp Main
CI2:
rcall  ConvDSExt      ;     DS1624,  
sbrs Sanct,2          ;    
rcall  OutWHDSExt     ;      
rjmp Main
CI3:
ldi   tmp1,ADMX        ;       
out   ADMUX,tmp1
ldi   tmp1,ADSM        ;      
out   ADCSR,tmp1
ldi  tmp1,0b10010000   ;  "" 
out  MCUCR,tmp1       
sleep                  ;   
in   hexL,ADCL         ;   -
in   hexH,ADCH         ;   -
rcall  CalcPress
rcall  HexBCDm
sbrs Sanct,3           ;    
rcall  PressLCD        ;    
ldi  tmp1,0b00001110   ;   
out  ADCSR,tmp1
ldi  tmp1,0 
out  TWCR,tmp1         ;     
rjmp   Main

LoadTimer1:  ;   1,    

in Save,SREG       ;    
push tmp1
inc XL                 ;     
ldi  tmp1,Time1H       ;    1    
out  TCNT1H,tmp1
ldi  tmp1,Time1L 
out  TCNT1L,tmp1
cpi XL,4
breq CI4
pop tmp1
ret
CI4:
clr XL
clr Sanct
pop tmp1               ;    
out SREG,Save
ret  

Check:           ;     PCF8583

lds tmp1,SV8
cpi tmp1,0b01011001      ;     59
breq WD7                ;   -   ,   
rjmp ALARM
WD7:
rjmp Monitor        

Monitor:         ;    

ldi tmp1,1
mov m1,tmp1          ;  EEPROM
lds tmp1,SV0         ;       
sts SV10,tmp1        ;     , (T - N) 
rcall EEWrite        ;   EEPROM
ldi tmp1,2
mov m1,tmp1          ;  EEPROM
lds tmp1,SV1 
sts SV11,tmp1
rcall EEWrite        ;   EEPROM
ldi r29,$A0          ;   
ldi r28,0            ;   , 
ldi r27,0            ;        
rcall WritePCF       ;    
ldi r28,0
lds r27,SV2          ;      
                     ;     
rcall WritePCF       ;    
ldi r28,7            ;   
ldi r27,0            ;  
rcall WritePCF       ;    

        ;      
ldi tmp1,100        ;   ,  
                    ;    
WD8:
cbi  PortB,5        ;   
sbi DDRB,5          ;     0
rcall Wait05ms      ;   
cbi DDRB,5          ;     1
rcall Wait05ms      ;   
dec tmp1
cpi tmp1,0
breq WD9
rjmp WD8
WD9:
rjmp Main

OutWHDS:    ;      

rcall  HexBCD          ;   
rcall  Poz2            ;    
rcall  XBruchD         ;   
rcall  Poz6            ;    
ldi tmp1,0b00000010
mov Sanct,tmp1         ;      -
ret

OutWHDSExt: ;      

rcall  HexBCD          ;   
rcall  Poz2            ;    
rcall  XBruchD         ;   
rcall  Poz6Ext         ;    
ldi tmp1,0b00000100
mov Sanct,tmp1         ;      -
ret

InitLCD:   ;  -

rcall Wait5ms	;   20    
rcall Wait5ms
rcall Wait5ms
rcall Wait5ms
ldi   prm1,$38  ; $38:  , 8 
rcall SendCom	;    -
rcall Wait5ms     	;   5 
ldi   prm1,$38	; $38:  , 8 
rcall SendCom	;  
rcall Wait5ms       ;   5 
ldi   prm1,$38	; $38:  , 8 
rcall SendCom	;  
rcall Wait5ms     	;   5 
ldi   prm1,$08	; $08:  , , 
rcall SendCom	;  
rcall Wait50us     	;   50 
rcall WaitBusy	;   -  
rcall SendCom	;  
ldi   prm1,$01	;  
rcall SendCom	;  
rcall Wait5ms       ;   5 
rcall WaitBusy	;   -  
ldi   prm1,$06	;   ,  
rcall SendCom	;  
rcall Wait50us      ;   50 
ret

ChoiceDS:    ;    ,  

ldi r29,$90      ;  
ldi r28,$AC      ;   
ldi r27,0        ; 
rcall InitDS
ret

ChoiceDSExt: ;    ,  

ldi r29,$92      ;  
ldi r28,$AC      ;   
ldi r27,0        ; 
rcall InitDS
ret

InitDS:      ;  DS1624

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait1:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait1

out  TWDR,r29;   TWDR   
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait2:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait2
            
out  TWDR,r28 ; ,   DS1624  
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait3:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait3

out  TWDR,r27
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait4:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait4

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1

rcall Wait5ms  ; , 15 ,    EEPROM
rcall Wait5ms
rcall Wait5ms

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait5:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait5

out  TWDR,r29  ;   TWDR   
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait6:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait6

ldi  r28,$EE  ; ,  
out  TWDR,r28
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait7:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait7

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret

OutWH2:      ;   

wdr
ldi   prm1,$0C	    ;  , .   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   prm1,$01	    ;  ,    
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text16)
ldi   ZL,low(Text16); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
ldi   prm1,$C0	    ;  9-   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text17)
ldi   ZL,low(Text17); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
rcall  Wait1000     ;  2.0 
rcall  Wait1000 
ret

OutWH3:      ; 

wdr
ldi   prm1,$0C	    ;  , .   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   prm1,$01	    ;  ,    
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text29)
ldi   ZL,low(Text29); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
ldi   prm1,$C0	    ;  9-   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text30)
ldi   ZL,low(Text30); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
rcall  Wait1000     ;  2.0 
rcall  Wait1000 
ret

OutWH4:      ;  

wdr
ldi   prm1,$0C	    ;  , .   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   prm1,$01	    ;  ,    
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text44)
ldi   ZL,low(Text44); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
ldi   prm1,$C0	    ;  9-   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text45)
ldi   ZL,low(Text45); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
rcall  Wait1000     ;  2.0 
rcall  Wait1000 
ret

OutWH5:      ;    RTC

wdr
ldi   prm1,$0C	    ;  , .   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   prm1,$01	    ;  ,    
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text46)
ldi   ZL,low(Text46); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
ldi   prm1,$C0	    ;  9-   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text47)
ldi   ZL,low(Text47); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
rcall  Wait1000     ;  2.0 
rcall  Wait1000 
ret

ConvDS:  ;     DS1624,  

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait8:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait8

ldi  tmp1,$90   ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait9:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait9

ldi  tmp1,$AA    ; ,  
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait10:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait10

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait11:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait11

ldi  tmp1,$91   ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) 
out  TWCR,tmp1
wait12:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait12
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA) 
out  TWCR,tmp1
wait13:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait13

in   hexH,TWDR
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWEA) 
out  TWCR,tmp1
wait14:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait14

in   hexL,TWDR

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1

bst  hexH,7     ;     
brtc Plus       ; ,   
neg  hexL       ;   
com  hexH       ;   
ldi tmp1,$2D    ;  
sts SV12,tmp1
ret
Plus:
ldi tmp1,$2B    ;  
sts SV12,tmp1
ret

ConvDSExt:  ;     DS1624,  

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait109:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait109

ldi  tmp1,$92   ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait110:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait110

ldi  tmp1,$AA    ; ,  
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait111:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait111

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait112:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait112

ldi  tmp1,$93   ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) 
out  TWCR,tmp1
wait113:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait113
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA) 
out  TWCR,tmp1
wait114:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait114

in   hexH,TWDR
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (0<<TWEA) 
out  TWCR,tmp1
wait115:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait115

in   hexL,TWDR

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1

bst  hexH,7     ;     
brtc Plus2      ; ,   
neg  hexL       ;   
com  hexH       ;   
ldi tmp1,$2D    ;  
sts SV12,tmp1
ret
Plus2:
ldi tmp1,$2B    ;  
sts SV12,tmp1
ret

SendCom:	;   - 
cbi   PortC,RS	; Register Select = 
rcall Ausgabe
ret

SendDat:	;   -  
sbi   PortC,RS	; Register Select =  
rcall Ausgabe
ret

Ausgabe:	;   = 8 
out   PortD,prm1	;  /   D
sbi   PortC,Ena	;   
nop
nop
nop
nop	            ;     450 
cbi   PortC,Ena	;   
ret

WaitBusy:	;   -  
clr   tmp1
out   DDRD,tmp1	;  D = 
cbi   PortC,RS	; Register Select = 
sbi   PortC,RW	;  =   -
WB1:
sbi   PortC,Ena	;   
nop
nop
nop
nop	            ;  . 320   
in    tmp1,PinD	;  BF    
cbi   PortC,Ena	;   
nop
nop
sbrc  tmp1,BF	;   ,  -  (BF=0)
rjmp  WB1
cbi   PortC,RW	;   =  -
ser   tmp1
out   DDRD,tmp1	;  D = 
ret

Wait50us:	    ;    = 8 
ldi   tim1,130	;  
Wait51:
dec   tim1
brne  Wait51
ret

Wait05ms:	    ;    = 8 
ldi   tim2,10	;  
Wait52:
rcall wait50us
dec   tim2
brne  Wait52
ret

Wait150us:	    ;    = 8 
rcall wait50us
rcall wait50us
rcall wait50us
ret

Wait5ms:	    ;    = 8 
ldi   tim2,100	;  
Wait53:
rcall wait50us
dec   tim2
brne  Wait53
ret

Wait250:        	;   0.25 
ldi   tmp1,0	    ;   
out   TCNT0,tmp1	;  T/C0
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0
ldi   tim2,8	    ; 8   
Wait251:
in    tmp1,TIFR	    ;    TIFR
sbrs  tmp1,TOV0	    ;   ,   - 
rjmp  Wait251	    ;   
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1    	;   TOV0
dec   tim2
brne  Wait251	    ; 8  = 0.25 
ret

Wait1000:        	;   1 
ldi   tmp1,0	    ;   
out   TCNT0,tmp1	;  T/C0
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1	    ;   TOV0
ldi   tim2,32	    ; 32   
Wait:
in    tmp1,TIFR	    ;    TIFR
sbrs  tmp1,TOV0	    ;   ,   - 
rjmp  Wait	        ;   
ldi   tmp1,1<<TOV0	;     TOV0
out   TIFR,tmp1    	;   TOV0
dec   tim2
brne  Wait	        ; 32  = 1 
ret

Poz2:        ;   

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SV12  ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
andi  BCD1,$0F   ; 
ori   BCD1,$30   ;    
mov   prm1,BCD1  ;   3
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
mov   tmp2,BCD0  ;  BCD0  tmp2
swap  BCD0       ;    
andi  BCD0,$0F   ; 
ori   BCD0,$30   ;    
mov   prm1,BCD0  ;   2
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
mov   BCD0,tmp2  ;  BCD0 
andi  BCD0,$0F   ; 
ori   BCD0,$30   ;    
mov   prm1,BCD0  ;   1
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$2E   ;  
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ret

Poz6:         ;   ,  

mov   tmp2,BCD1  ;  BCD1  tmp2
swap  BCD1       ;    
andi  BCD1,$0F   ; 
ori   BCD1,$30   ;    
mov   prm1,BCD1  ;   4
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
mov   BCD1,tmp2  ;  BCD1 
andi  BCD1,$0F   ; 
ori   BCD1,$30   ;    
mov   prm1,BCD1  ;   3
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$EF   ;   
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$C0   ;   9
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   ZH,high(Text18)
ldi   ZL,low(Text18); Z    
ldi   Cnt,8	        ;    8 c
rcall OutText       ;    
ret

Poz6Ext:         ;   ,  

mov   tmp2,BCD1  ;  BCD1  tmp2
swap  BCD1       ;    
andi  BCD1,$0F   ; 
ori   BCD1,$30   ;    
mov   prm1,BCD1  ;   4
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
mov   BCD1,tmp2  ;  BCD1 
andi  BCD1,$0F   ; 
ori   BCD1,$30   ;    
mov   prm1,BCD1  ;   3
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$EF   ;   
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$C0   ;   9
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   ZH,high(Text31)
ldi   ZL,low(Text31); Z    
ldi   Cnt,8	        ;    8 c
rcall OutText       ;    
ret

HexBCD:	        ; xx (Hex) -> 0abc (BCD)
rcall Div10	    ; hexH / 10, -  tmp1
mov   BCD0,tmp1	;   hexH, tmp1 =  1
rcall Div10
swap  tmp1      ;  2   
or    BCD0,tmp1 ;   2  1  BCD0 
rcall Div10	
mov   BCD1,tmp1	;   4  3  BCD1 
ret

XBruchD:	    ; 0,ab (HEX) -> 0,4321 (BCD)
rcall Mul10	
swap  tmp1	    ;  tmp1 =  4
mov   BCD1,tmp1	;  4   BCD1
rcall Mul10	
or    BCD1,tmp1	;   4  3  BCD1
rcall Mul10	
swap  tmp1	    ;  2    
mov   BCD0,tmp1	;  2     BCD0
rcall Mul10	
or    BCD0,tmp1	;   2  1  BCD0
ret

Div10:	
clr  tmp1
lsl  hexH
rol  tmp1	    ;     10  
ldi  Cnt,7	    ;   7 
Loop10:
lsl  hexH	    ;     1 
rol  tmp1	    ;   tmp1
subi tmp1,10	; ;  > 10 ?
brlo HB1	    ; ,  
inc  hexH       ;    1
rjmp HB2
HB1:
subi tmp1,-10	;   
HB2:
dec  Cnt	    ;   
brne Loop10	
ret

Mul10:	
clr  tmp1	    ; ...  -  tmp1
lsl  hexL	    ;   2
rol  tmp1	    ; 
mov  cpyL,hexL	;   
mov  tmp2,tmp1
lsl  cpyL	    ;   2 ( -  4)
rol  tmp1	    ; 
lsl  cpyL	    ;   2 ( -  8)
rol  tmp1	    ; 
add  hexL,cpyL	;    ( x 2)
adc  tmp1,tmp2	;  0...9   tmp1
ret

CalcPress:  ;     ,(  )

ldi tmp1,$BE          ;   9150   / 
mov m0,tmp1           ;    
ldi tmp1,$23 
mov m1,tmp1
mov m2,hexL           ;      / 
mov m3,hexH
ldi tmp1,0            ;  0   
mov m4,tmp1
mov m5,tmp1
mov m6,tmp1
mov m7,tmp1

rcall MUL42

ldi tmp1,$10          ;   10000   / 
mov m0,tmp1
ldi tmp1,$27
mov m1,tmp1

rcall DIV42

mov hexL,m4           ;    
mov hexH,m5
ret

MUL42:             ;  
ldi  tmp1,0x10

MUL1: 
mov  tmp2,m2         ; , m3:m2 * m1:m0
ror  tmp2            ;   m7:m6:m5:m4
brcc  MUL2
mov  tmp2,m6
add  tmp2,m0
mov  m6,tmp2
mov  tmp2,m7
adc  tmp2,m1
mov  m7,tmp2

MUL2:
mov  tmp2,m7
ror  tmp2
mov  m7,tmp2
mov  tmp2,m6
ror  tmp2
mov  m6,tmp2
mov  tmp2,m5
ror  tmp2
mov  m5,tmp2
mov  tmp2,m4
ror  tmp2
mov  m4,tmp2
mov  tmp2,m3
ror  tmp2
mov  m3,tmp2
mov  tmp2,m2
ror  tmp2
mov  m2,tmp2
dec  tmp1
cpi  tmp1,0
brne MUL1
ret

DIV42:        ;  

ldi  tmp1,0x10

DCLK42:
clc
mov  tmp2,m4         ;   m7:m6:m5:m4
rol  tmp2            ;   m1:m0
mov  m4,tmp2         ;   m5:m4
mov  tmp2,m5
rol  tmp2
mov  m5,tmp2
mov  tmp2,m6
rol  tmp2
mov  m6,tmp2
mov  tmp2,m7
rol  tmp2
mov  m7,tmp2
in   Cnt,SREG
push Cnt
PER1:
clc
mov  tmp2,m6
sbc  tmp2,m0
mov  m6,tmp2
mov  tmp2,m7
sbc  tmp2,m1
mov  m7,tmp2
brcs PER2
pop  Cnt
out  SREG,Cnt
PER3:
inc m4
rjmp PER4
PER2:
pop  Cnt
out  SREG,Cnt
brcs PER3
mov  tmp2,m6
add  tmp2,m0
mov  m6,tmp2
mov  tmp2,m7
adc  tmp2,m1
mov  m7,tmp2
PER4:
dec  tmp1
cpi  tmp1,0
brne DCLK42
ret

HexBCDm:	    ; xxxx (Hex) -> bcde (BCD)
rcall Div10m	; hexH:hexL / 10,  -  tmp1
mov   BCD0,tmp1	;  -  hexH:hexL, tmp1 =  1
rcall Div10m	;  =  2
swap  tmp1	    ;  2    
or    BCD0,tmp1	;   2  1  BCD0
sts SV1,BCD0    ;      
rcall Div10m	;  =  3
mov   BCD1,tmp1	;  BCD1
rcall Div10m	;  =  4
swap  tmp1	    ;  4    
or    BCD1,tmp1	;   4  3  BCD1
sts SV0,BCD1    ;      
ret

Div10m:	        ;  hexH:hexL  10,
	            ;    hexH:hexL,  -  tmp1
clr  tmp1
lsl  hexL
rol  hexH
rol  tmp1       ;      10
lsl  hexL	    ;       
rol  hexH   	;    0
rol  tmp1
lsl  hexL
rol  hexH
rol  tmp1
lsl  hexL
rol  hexH
rol  tmp1
lsl  hexL
rol  hexH
rol  tmp1
lsl  hexL
rol  hexH
rol  tmp1
ldi  cnt,10	    ;    10 s
Loop10m:
lsl  hexL	    ;     1 
rol  hexH
rol  tmp1    	;   tmp1
subi tmp1,10	; :  > 10 ?
brlo HBm1   	    ; ,  
inc  hexL       ;     1
rjmp HBm2
HBm1:
subi tmp1,-10	;   
HBm2:
dec  cnt    	;   
brne Loop10m	; ,     
ret

PressLCD:     ;   

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
lds   prm1,SV0   ;    
andi  prm1,$0F   ; 
ori   prm1,$30   ;    
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds   prm1,SV1   ;    
swap  prm1       ;    
andi  prm1,$0F   ; 
ori   prm1,$30   ;    
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds   prm1,SV1   ;    
andi  prm1,$0F   ; 
ori   prm1,$30   ;    
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$5F   ;  _
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$54   ;   T
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$6F   ;   o
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$72   ;   r
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$72   ;   r
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$C0   ;   9
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$20   ; 
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds   prm1,SV10  ;    
andi  prm1,$0F   ; 
ori   prm1,$30   ;    
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds   prm1,SV11  ;    
swap  prm1       ;    
andi  prm1,$0F   ; 
ori   prm1,$30   ;    
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
lds   prm1,SV11  ;    
andi  prm1,$0F   ; 
ori   prm1,$30   ;    
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   ZH,high(Text34)
ldi   ZL,low(Text34); Z    
ldi   Cnt,8	        ;    8 c
rcall OutText       ;    
ldi tmp1,0b00001000 
mov Sanct,tmp1      ;      -
ret

InsClock:         ;  

wdr
rcall OutWHCM        ;     
ldi  r29,$A0         ;   
ldi  r28,0
ldi  r27,0b10000000  ;   ,  
rcall WritePCF
ldi  r28,2
ldi  tmp1,0          ;     0
mov  hexL,tmp1
ldi  tmp1,TimeH      ;    1    
out  TCNT1H,tmp1
ldi  tmp1,TimeL 
out  TCNT1L,tmp1
ldi   tmp1,5	     ;  
out   TCCR1B,tmp1    ;  T/C1,  . = 1024
ldi  tmp1,(1<<TOIE1)
out  TIMSK,tmp1      ;    
sei                  ;   
REP:
wdr
clr I1
in  I1,PINB          ;    SB4 
sbrc I1,3            ;   ,    
rjmp REP
clr I1
in  I1,PINB          ;    SB5
sbrc I1,4            ;   ,    
rjmp REP 
rcall ReadPCFS       ;    Status  
ldi r29,$A0          ;   
ldi r28,7            ;   
ldi r27,0            
rcall WritePCF       
ldi r28,2            ;    
ldi r27,0
rcall WritePCF
ldi r28,1            ;    0,1 
ldi r27,0
rcall WritePCF
rjmp OutWHBM         ;        

Timer_Int1:		     ;    T1
wdr
clr  tmp1
in  tmp1,PINB        ;    SB2
sbrs tmp1,1          ;   ,    
inc  R28             ;    PCF8583, UP
clr  tmp1
in  tmp1,PINB        ;    SB3
sbrs tmp1,2          ;   ,    
dec  R28             ;    PCF8583, DOWN
cpi  R28,0           ;  00   
breq Sel0
cpi  R28,1           ;  01   0,01 
breq Sel1
cpi  R28,2           ;  02   
breq Sel2
cpi  R28,3           ;  03   
breq Sel3
cpi  R28,4           ;  04   
breq Sel4
cpi  R28,5           ;  05   
breq Sel5
cpi  R28,6           ;  06   
breq Sel6
cpi  R28,7           ;  07  
breq Sel7
cpi  R28,8           ;  08   
breq Sel8
cpi  R28,9           ;  09   0,01  '' 
breq Sel9
cpi  R28,10          ;  10     '' 
breq Sel10
cpi  R28,11          ;  11    '' 
breq Sel11
cpi  R28,12          ;  12    '' 
breq Sel12
cpi  R28,13          ;  13    '' 
breq Sel13
cpi  R28,14          ;  14    ''
breq Sel14
cpi  R28,15          ;  15  '' 
breq Sel15
Sel0:
ldi   ZH,high(Text0)
ldi   ZL,low(Text0)	; Z    
rcall OutWHvar         ;    
rjmp  Home
Sel1:
ldi   ZH,high(Text1)
ldi   ZL,low(Text1)	; Z    
rcall OutWHvar         ;    
rjmp  Home
Sel2:
ldi   ZH,high(Text2)
ldi   ZL,low(Text2)	; Z    
rcall OutWHvar         ;    
rjmp  Home
Sel3:
ldi   ZH,high(Text3)
ldi   ZL,low(Text3)	; Z    
rcall OutWHvar         ;    
rjmp  Home 
Sel4:
ldi   ZH,high(Text4)
ldi   ZL,low(Text4)	; Z    
rcall OutWHvar         ;    
rjmp  Home
Sel5:
ldi   ZH,high(Text5)
ldi   ZL,low(Text5)	; Z    
rcall OutWHvar         ;    
rjmp  Home
Sel6:
ldi   ZH,high(Text6)
ldi   ZL,low(Text6)	; Z    
rcall OutWHvar         ;    
rjmp  Home
Sel7:
ldi   ZH,high(Text7)
ldi   ZL,low(Text7)	; Z    
rcall OutWHvar         ;    
rjmp  Home
Sel8:
ldi   ZH,high(Text8)
ldi   ZL,low(Text8)	; Z    
rcall OutWHvar         ;    
rjmp  Home
Sel9:
ldi   ZH,high(Text9)
ldi   ZL,low(Text9); Z    
rcall OutWHvar         ;    
rjmp  Home
Sel10:
ldi   ZH,high(Text10)
ldi   ZL,low(Text10); Z    
rcall OutWHvar         ;    
rjmp  Home
Sel11:
ldi   ZH,high(Text11)
ldi   ZL,low(Text11); Z    
rcall OutWHvar         ;    
rjmp  Home
Sel12:
ldi   ZH,high(Text12)
ldi   ZL,low(Text12); Z    
rcall OutWHvar         ;    
rjmp  Home
Sel13:
ldi   ZH,high(Text13)
ldi   ZL,low(Text13); Z    
rcall OutWHvar         ;    
rjmp  Home
Sel14:
ldi   ZH,high(Text14)
ldi   ZL,low(Text14); Z    
rcall OutWHvar         ;    
rjmp  Home
Sel15:
ldi   ZH,high(Text15)
ldi   ZL,low(Text15); Z    
rcall OutWHvar         ;    
rjmp  Home

Home:       ;   

clr  tmp1
in  tmp1,PINB        ;    SB4
sbrs tmp1,3          ;   ,    
inc  hexL            ;     PCF8583, UP
clr  tmp1
in  tmp1,PINB        ;    SB5
sbrs tmp1,4          ;   ,    
dec  hexL            ;     PCF8583, DOWN
mov  r27,hexL        ;    
clr  tmp1
in  tmp1,PINB        ;    SB1
sbrs tmp1,0          ;   ,     
rjmp OutWHW          ;     PCF8583
Return:
ldi  tmp1,TimeH      ;    1    
out  TCNT1H,tmp1
ldi  tmp1,TimeL 
out  TCNT1L,tmp1
ldi   tmp1,5	     ;  
out   TCCR1B,tmp1    ;  T/C1,  . = 1024
ldi  tmp1,(1<<TOIE1)
out  TIMSK,tmp1      ;    
reti                 ;     
             	 

WritePCF:    ;     PCF8583 

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait15:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait15

out  TWDR,r29
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait16:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait16

out  TWDR,r28  ;   TWDR  -
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait17:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait17

out  TWDR,r27  ;   TWDR 
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait18:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait18

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret

ReadPCFcur:    ;     PCF8583   

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait19:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait19

ldi  tmp1,$A0     ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait20:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait20

ldi  tmp1,$03 
          
out  TWDR,tmp1    ;   TWDR  -
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait21:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait21

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait22:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait22

ldi  tmp1,$A1   ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) 
out  TWCR,tmp1
wait23:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait23
                ;    ()
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait24:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait24
in   BCD0,TWDR
sts SV8,BCD0  ;       

               ;    ()
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait25:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait25
in   BCD1,TWDR

              ;    ( )
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait26:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait26
in   BCD2,TWDR

             ;    ()
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (0<<TWEA)
out  TWCR,tmp1
wait27:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait27
in   I1,TWDR

ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
                          
ret

OutText:	;   <Cnt>  

lsl   ZL        ;  Z   1  ,  7    
rol   ZH	    ;  Z   1  ,   
OT1:
lpm	            ;     r0
mov   prm1,r0	;     prm1
rcall WaitBusy	;   -  
rcall SendDat	;  ,  
adiw  ZL,1	    ;   Z
dec   Cnt	    ;   1
brne  OT1	    ;     -
ret

OutWHvar:        ;   

ldi   prm1,$0C	 ;  , .   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$01	 ;  ,    
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   prm1,$76   ;   v
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$61   ;   a
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$72   ;   r
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$5F   ;   _
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
mov   tmp2,R27   ;  R27  tmp2
swap  R27        ;    
andi  R27,$0F    ; 
cpi r27,10       ;     10
brge BinDec2     ;   ,     10
ori   R27,$30    ;   
rjmp Bin1   
BinDec2:
add   R27,sum    ;   
Bin1: 
mov   prm1,R27   ;   2
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
mov   R27,tmp2   ;  R27
andi  R27,$0F    ; 
cpi r27,10       ;     10
brge BinDec1     ;   ,   10
ori   R27,$30    ;   
rjmp Bin2
BinDec1:
add   R27,sum    ;   
Bin2:
mov   prm1,R27   ;   1
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$20   ; 
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$20   ; 
rcall WaitBusy	 ;   -  
rcall SendDat    ;  
ldi   prm1,$C0	 ;  9-   
rcall WaitBusy	 ;   -  
rcall SendCom	 ;  
ldi   Cnt,8	     ;    8 
rcall OutText    ;    
ret

OutWHcur:     ;      

ldi   prm1,$0C	  ;  , .   
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$01	  ;  ,    
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
mov   tmp2,BCD1   ;  BCD1  tmp2
swap  BCD1        ;    
andi  BCD1,$0F    ; 
ori   BCD1,$30    ;    
mov   prm1,BCD1   ;   4
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   BCD1,tmp2   ;  BCD1
andi  BCD1,$0F    ; 
ori   BCD1,$30    ;    
mov   prm1,BCD1   ;   3
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$3A    ; 
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   tmp2,BCD0   ;  BCD0  tmp2
swap  BCD0        ;    
andi  BCD0,$0F    ; 
ori   BCD0,$30    ;    
mov   prm1,BCD0   ;   2
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   BCD0,tmp2   ;  BCD0
andi  BCD0,$0F    ; 
ori   BCD0,$30    ;    
mov   prm1,BCD0   ;   1
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$20    ; 
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   tmp2,BCD2   ;  BCD2  tmp2
swap  BCD2        ;    
andi  BCD2,$0F    ; 
ori   BCD2,$30    ;    
mov   prm1,BCD2   ;   4
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   BCD2,tmp2   ;  BCD0
andi  BCD2,$0F    ; 
ori   BCD2,$30    ;    
mov   prm1,BCD2   ;   3
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$C0	  ;  9-   
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$2F    ;  '/'
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   tmp2,I1     ;  I1  tmp2
swap  I1          ;    
andi  I1,$0F      ; 
ori   I1,$30      ;    
mov   prm1,I1     ;   2
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   I1,tmp2     ;  I1
andi  I1,$0F      ; 
ori   I1,$30      ;    
mov   prm1,I1     ;   1
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$20    ; 
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
lds tmp2,SV3      ;     1   
mov   prm1,tmp2    
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
lds tmp2,SV4      ;     2   
mov   prm1,tmp2    
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
lds tmp2,SV5      ;     3   
mov  prm1,tmp2    
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$20    ; 
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi tmp1,0b00000001
mov Sanct,tmp1    ;      -
ret

ALARM:         ;   

wdr
ldi tmp1,0          ;      
out TIMSK,tmp1
rcall OutWHAL       ;   "ALARM"  LCD
ldi  I1,255         ;   ,  
                    ;    
REP2:
wdr
cbi PortB,5         ;   
nop
sbi DDRB,5          ;   
rcall Wait05ms      
cbi DDRB,5          
rcall Wait05ms 
dec  I1
cpi  I1,0
breq REP3     
rjmp REP2
REP3:
rcall Wait250       ;    
rcall Wait250
dec Stime           ;     
mov I1,Stime        ;  Stime   '' 
cpi I1,0            ;   0
breq REP4           ; ,  0
rjmp ALARM
REP4:
ldi r29,$A0         ;   
ldi r28,0
lds r27,0           ;            
rcall WritePCF           
ldi r29,$A0         ;    
ldi r28,0
lds r27,SV2         ;      
                    ;   
rcall WritePCF
ldi tmp1,$1E
mov Stime,tmp1      ;                                             

rjmp  OutWHBM       ;      

TimStart:     ;    PCF8583
wdr
rcall OutWHWork    ;    ( )
cpi BCD2,0         ; ,   0,  
breq REP6
REP5:              ;   ,  
rcall ReadPCFSec   ;    
cpi BCD1,0         ;    0    
breq REP6
rjmp REP5
REP6:
ldi r29,$A0        ;   Timer 
ldi r28,7
ldi r27,0
rcall WritePCF
rcall Sound        ;  '  ' 
REP7:
wdr
rcall ReadTim       ;   
rcall OutWHCTim
in  tmp1,PINB       ;    (  )
sbrs tmp1,1         ;   ,    1
rjmp ALARMTimer     ;     
in  tmp1,PINB       ;    SB5 
sbrs tmp1,4         ;   ,    
rjmp StopTim        ;       
rjmp REP7

Sound:        ;     

ldi tmp1,50         ;   ,  
                    ;    
WD10:
cbi  PortB,5        ;   
sbi DDRB,5          ;     0
rcall Wait05ms      ;   
cbi DDRB,5          ;     1
rcall Wait05ms      ;   
dec tmp1
cpi tmp1,0
breq WD11
rjmp WD10
WD11:
ret

ReadStat:     ;       PCF8583

wdr
rcall ReadPCFSCT    ;    
rcall OutWHSCT      ;     
clr  tmp1
in  tmp1,PINB       ;    SB4
sbrs tmp1,3         ;   ,    1
rjmp ReadStat
ret

Currtime:    ;     LCD

wdr
rcall ReadPCF1 ;  /        PCF8583
rcall OutWH1   ;  /     PCF8583
clr  tmp1
in  tmp1,PINB  ;    SB3
sbrs tmp1,2    ;   ,    1
rjmp Currtime
ret

OutWH1:     ;        LCD

ldi   prm1,$0C	  ;  , .   
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$01	  ;  ,    
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
mov   tmp2,BCD2   ;  BCD2  tmp2
swap  BCD2        ;    
andi  BCD2,$0F    ; 
ori   BCD2,$30    ;    
mov   prm1,BCD2   ;   6
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   BCD2,tmp2   ;  BCD2
andi  BCD2,$0F    ; 
ori   BCD2,$30    ;    
mov   prm1,BCD2   ;   5
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$3A    ; 
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   tmp2,BCD1   ;  BCD1  tmp2
swap  BCD1        ;    
andi  BCD1,$0F    ; 
ori   BCD1,$30    ;    
mov   prm1,BCD1   ;   4
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   BCD1,tmp2   ;  BCD1
andi  BCD1,$0F    ; 
ori   BCD1,$30    ;    
mov   prm1,BCD1   ;   3
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$3A    ; 
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   tmp2,BCD0   ;  BCD0  tmp2
swap  BCD0        ;    
andi  BCD0,$0F    ; 
ori   BCD0,$30    ;    
mov   prm1,BCD0   ;   2
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   BCD0,tmp2   ;  BCD0
andi  BCD0,$0F    ; 
ori   BCD0,$30    ;    
mov   prm1,BCD0   ;   1
rcall WaitBusy	  ;   -  
rcall SendDat     ;   
ldi   prm1,$C0	  ;    9
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$54    ;  
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$20    ; 
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   tmp2,I1     ;  I1  tmp2
swap  I1          ;    
andi  I1,$0F      ; 
ori   I1,$30      ;    
mov   prm1,I1     ;   4
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   I1,tmp2     ;  I1
andi  I1,$0F      ; 
ori   I1,$30      ;    
mov   prm1,I1     ;   4
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$3A    ; 
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   tmp2,tim1   ;  tim1  tmp2
swap  tim1        ;    
andi  tim1,$0F    ; 
ori   tim1,$30    ;    
mov   prm1,tim1   ;   2
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   tim1,tmp2   ;  tim1
andi  tim1,$0F    ; 
ori   tim1,$30    ;    
mov   prm1,tim1   ;   1
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$41    ;  
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
rcall Wait250     ;  0.25 
ret

ReadPCF1:    ;     ''   PCF8583

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait28:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait28

ldi  tmp1,$A0     ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait29:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait29

ldi  tmp1,$02 
          
out  TWDR,tmp1    ;   TWDR  -
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait30:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait30

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait31:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait31

ldi  tmp1,$A1   ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) 
out  TWCR,tmp1
wait32:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait32
                ;    ()
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait33:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait33
in   BCD0,TWDR
               ;    ()
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)   
out  TWCR,tmp1
wait34:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait34
in   BCD1,TWDR
                ;    ()
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait35:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait35
in   BCD2,TWDR
               ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)      
out  TWCR,tmp1
wait36:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait36
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait37:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait37
               ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait38:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait38
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait39:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait39
               ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)    
out  TWCR,tmp1
wait40:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait40
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)    
out  TWCR,tmp1
wait41:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait41
                 ;    ( )
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait42:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait42
in   tim1,TWDR
                ;    ( )
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (0<<TWEA)
out  TWCR,tmp1
wait43:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait43
in   I1,TWDR 
           
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret

OutWHCM:      ;   

wdr
ldi   prm1,$0C	    ;  , .   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   prm1,$01	    ;  ,    
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text23)
ldi   ZL,low(Text23)	; Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
ldi   prm1,$C0	    ;  9-   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text24)
ldi   ZL,low(Text24); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
rcall  Wait1000     ;  1.0 
ret

OutWHAL:      ;   

ldi   prm1,$0C	    ;  , .   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   prm1,$01	    ;  ,    
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text32)
ldi   ZL,low(Text32); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
ldi   prm1,$C0	    ;  9-   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text33)
ldi   ZL,low(Text33); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
ret

OutWHW:      ;     

wdr
ldi   prm1,$0C	    ;  , .   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   prm1,$01	    ;  ,    
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text35)
ldi   ZL,low(Text35); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
ldi   prm1,$C0	    ;  9-   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text36)
ldi   ZL,low(Text36); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
rcall  Wait1000     ;  1.0 
rcall WritePCF
rjmp Return

OutWHBM:      ;      

wdr
ldi  tmp1,Time1H      ;    1    
out  TCNT1H,tmp1      ;     
ldi  tmp1,Time1L 
out  TCNT1L,tmp1
ldi tmp1,$FF
out OCR1AH,tmp1       ;    1 
out OCR1AL,tmp1
ldi tmp1,(1<<OCIE1A);      
out TIMSK,tmp1
ldi   prm1,$0C	    ;  , .   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   prm1,$01	    ;  ,    
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text37)
ldi   ZL,low(Text37)	; Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
ldi   prm1,$C0	    ;  9-   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text38)
ldi   ZL,low(Text38); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
rcall  Wait1000     ;  1.0 
clr XL
rjmp  Main

    ;      

Text0:
.db   "Status  "  ;  00  PCF8583
Text1:
.db   "H_second"  ;  01  PCF8583
Text2:
.db   "Seconds "  ;  02  PCF8583
Text3:
.db   "Minutes "  ;  03  PCF8583
Text4:
.db   "Hours   "  ;  04  PCF8583
Text5:
.db   "Year/Dat"  ;  05  PCF8583
Text6:
.db   "Months  "  ;  06  PCF8583
Text7:
.db   "Timer   "  ;  07  PCF8583
Text8:
.db   "Control "  ;  08  PCF8583
Text9:
.db   "Alarm_HS"  ;  09  PCF8583
Text10:
.db   "Alarm_S "  ;  0A  PCF8583
Text11:
.db   "Alarm_M "  ;  0B  PCF8583
Text12:
.db   "Alarm_H "  ;  0C  PCF8583
Text13:
.db   "Al_date "  ;  0D  PCF8583
Text14:
.db   "Al_month"  ;  0E  PCF8583
Text15:
.db   "Al_timer"  ;  0F  PCF8583
Text16:
.db   "*AVANGAR"  ;  
Text17:
.db   "D-Micro*" 
Text18:
.db   "C> ROOM "  ;   
Text19:
.db   "_Count  "  ;   
Text20:
.db   " of Time"
Text21:
.db   "Time_sec"  ;   
Text22:
.db   "Time_min"  ;   
Text23:
.db   "   Mode "  ;  
Text24:
.db   "Clock   "
Text25:
.db   "   Mode "  ;  
Text26:
.db   "Timer   "  
Text27:
.db   " Start o"  ;  
Text28:
.db   "f Timer "  
Text29:
.db   "*****HEL"  ; 
Text30:
.db   "LO!*****" 
Text31:
.db   "C>STREET" ;    
Text32:
.db   "----*ALA"  ;  
Text33:
.db   "RM!*----"
Text34:
.db   "base    "  ;   
Text35:
.db   "   Write"  ;  
Text36:
.db   " Data   "
Text37:
.db   "   Basic"  ;    
Text38:
.db   " Mode   "
Text39:
.db   "TH limit"  ;  , HIGH
Text40:
.db   "TL limit"  ;  , LOW
Text41:
.db   "Config  "  ;   DS1621
Text42:
.db   "   Mode "  ;   
Text43:
.db   "Therm   "
Text44:
.db   " We begi"  ;  
Text45:
.db   "n work. "
Text46:
.db   " Stop of"  ;  
Text47:
.db   " Timer! "

ReadPCFSCT:    ;     PCF8583

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait44:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait44

ldi  tmp1,$A0     ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait45:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait45

ldi  tmp1,0 
          
out  TWDR,tmp1    ;   TWDR  -
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait46:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait46

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait47:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait47

ldi  tmp1,$A1   ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) 
out  TWCR,tmp1
wait48:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait48
                ;    (Status)
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait49:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait49
in   BCD0,TWDR
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait50:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait50

               ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)      
out  TWCR,tmp1
wait54:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait54
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait55:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait55
               ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait56:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait56
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait57:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait57
               ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)    
out  TWCR,tmp1
wait58:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait58

               ;    (Timer)
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)   
out  TWCR,tmp1
wait59:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait59
in   BCD1,TWDR

                ;    (Control)
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait60:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait60
in   BCD2,TWDR

               ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)      
out  TWCR,tmp1
wait61:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait61
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait62:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait62
               ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait63:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait63
                ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait64:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait64
               ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)    
out  TWCR,tmp1
wait65:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait65
          
                 ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (1<<TWEA)
out  TWCR,tmp1
wait66:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait66
                ;    (AL_Timer)
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (0<<TWEA)
out  TWCR,tmp1
wait67:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait67
in   tim2,TWDR 
          
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret

OutWHSCT:     ;     LCD

ldi   prm1,$0C	  ;  , .   
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$01	  ;  ,    
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
mov   tmp2,BCD0   ;  BCD0  tmp2
swap  BCD0        ;    
andi  BCD0,$0F    ; 
cpi   BCD0,10     ;     10
brge  BinDec3     ;   ,     10
ori   BCD0,$30    ;   
rjmp  Bin3
BinDec3:
add   BCD0,sum    ;   
Bin3:  
mov   prm1,BCD0   ;   2
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   BCD0,tmp2   ;  BCD0
andi  BCD0,$0F    ; 
cpi   BCD0,10     ;     10
brge  BinDec4     ;   ,     10
ori   BCD0,$30    ;   
rjmp  Bin4
BinDec4:
add   BCD0,sum    ;   
Bin4: 
mov   prm1,BCD0   ;   1
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$73    ;  s
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$3A    ; 
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   tmp2,BCD1   ;  BCD1  tmp2
swap  BCD1        ;    
andi  BCD1,$0F    ; 
ori   BCD1,$30    ;    
mov   prm1,BCD1   ;   2
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   BCD1,tmp2   ;  BCD1
andi  BCD1,$0F    ; 
ori   BCD1,$30    ;    
mov   prm1,BCD1   ;   1
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$74    ;  t
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$3A    ; 
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$C0	  ;    9
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
mov   tmp2,BCD2   ;  BCD2  tmp2
swap  BCD2        ;    
andi  BCD2,$0F    ; 
cpi   BCD2,10     ;     10
brge  BinDec5     ;   ,     10
ori   BCD2,$30    ;   
rjmp  Bin5
BinDec5:
add   BCD2,sum    ;   
Bin5:  
mov   prm1,BCD2   ;   2
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   BCD2,tmp2   ;  BCD2
andi  BCD2,$0F    ; 
cpi   BCD2,10     ;     10
brge  BinDec6     ;   ,     10
ori   BCD2,$30    ;   
rjmp  Bin6
BinDec6:
add   BCD2,sum    ;   
Bin6:  
mov   prm1,BCD2   ;   1
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$63    ;  c
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$3A    ; 
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   tmp2,tim2   ;  tim2  tmp2
swap  tim2        ;    
andi  tim2,$0F    ; 
ori   tim2,$30    ;    
mov   prm1,tim2   ;   2
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   tim2,tmp2   ;  tim2
andi  tim2,$0F    ; 
ori   tim2,$30    ;    
mov   prm1,tim2   ;   1
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$61    ;  a
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   prm1,$74    ;  t
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
rcall Wait250     ;  0.25 
ret
           	 

ReadPCFS:    ;   a Status   PCF8583

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait73:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait73

ldi  tmp1,$A0     ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait74:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait74

ldi  tmp1,0 
          
out  TWDR,tmp1    ;   TWDR  -
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait75:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait75

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait76:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait76

ldi  tmp1,$A1   ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) 
out  TWCR,tmp1
wait77:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait77
                ;    ()
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (0<<TWEA)
out  TWCR,tmp1
wait78:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait78
in   I1,TWDR
sts SV2,I1    ;     
    
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret

ReadPCFW:    ;     PCF8583   

ldi r29,$A0          ;   
ldi r28,0
ldi r27,0            ;      05  06
rcall WritePCF

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait79:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait79

ldi  tmp1,$A0     ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait80:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait80

ldi  tmp1,$06 
          
out  TWDR,tmp1    ;   TWDR  -
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait81:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait81

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait82:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait82

ldi  tmp1,$A1   ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) 
out  TWCR,tmp1
wait83:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait83
             
              ;    ( )
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (0<<TWEA)
out  TWCR,tmp1
wait84:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait84
in   I1,TWDR
                
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
             ;      05  06
ldi r29,$A0         ;   
ldi r28,0
lds r27,SV2         ;      
rcall WritePCF

         ;    Weekday/Month

swap  I1          ;   
andi  I1,$0E      ; ,   3,2,1   
cpi   I1,0        ;  0, 
breq  WD0 
cpi   I1,$02      ;  2, 
breq  WD1
cpi   I1,$04      ;  4, 
breq  WD2
cpi   I1,$06      ;  6, 
breq  WD3
cpi   I1,$08      ;  8, 
breq  WD4
cpi   I1,$0A      ;  A, 
breq  WD5
cpi   I1,$0C      ;  C, 
breq  WD6
WD0:
ldi tmp1,$4D     ;   'M','O','N'   
sts SV3,tmp1
ldi tmp1,$4F
sts SV4,tmp1
ldi tmp1,$4E
sts SV5,tmp1
ret
WD1:
ldi tmp1,$54     ;   'T','U','E'   
sts SV3,tmp1
ldi tmp1,$55
sts SV4,tmp1
ldi tmp1,$45
sts SV5,tmp1
ret
WD2:
ldi tmp1,$57     ;   'W','E','D'   
sts SV3,tmp1
ldi tmp1,$45
sts SV4,tmp1
ldi tmp1,$44
sts SV5,tmp1
ret
WD3:
ldi tmp1,$54     ;   'T','H','U'   
sts SV3,tmp1
ldi tmp1,$48
sts SV4,tmp1
ldi tmp1,$55
sts SV5,tmp1
ret
WD4:
ldi tmp1,$46     ;   'F','R','I'   
sts SV3,tmp1
ldi tmp1,$52
sts SV4,tmp1
ldi tmp1,$49
sts SV5,tmp1
ret
WD5:
ldi tmp1,$53     ;   'S','A','T'   
sts SV3,tmp1
ldi tmp1,$41
sts SV4,tmp1
ldi tmp1,$54
sts SV5,tmp1
ret
WD6:
ldi tmp1,$53     ;   'S','U','N   
sts SV3,tmp1
ldi tmp1,$55
sts SV4,tmp1
ldi tmp1,$4E
sts SV5,tmp1
ret

InsTimer:         ;   PCF8583

wdr
rcall OutWHITim      ;     
rcall ReadPCFS       ;         
rcall ReadPCFC
rcall ReadPCFA
ldi BCD0,0
ldi  tmp1,$0C        ;  ,     2,
mov  tim3,tmp1       ;    
ldi  r29,$A0         ;   
ldi  tmp1,0          ;    2 
out  TCNT2,tmp1
ldi   tmp1,7	     ;  
out   TCCR2,tmp1     ;  T/C2,  . = 1024
ldi  tmp1,(1<<TOIE2)
out  TIMSK,tmp1      ;    
sei                  ;   
REP10:
wdr
clr I1
in  I1,PINB          ;    SB4
sbrc I1,3            ;   ,    
rjmp REP10
clr I1
in  I1,PINB          ;    SB5
sbrc I1,4            ;   ,    
rjmp REP10 
ldi  tmp1,(0<<TOIE2)
out  TIMSK,tmp1      ;    
rjmp TimStart

Timer_Int2:		  ;    T2

wdr
mov tmp1,tim3        ;     T2
dec tmp1
mov tim3,tmp1
cpi tmp1,0
breq REP11
ldi  tmp1,0          ;    2 
out  TCNT2,tmp1
ldi   tmp1,7	     ;  
out   TCCR2,tmp1     ;  T/C2,  . = 1024
ldi  tmp1,(1<<TOIE2)
out  TIMSK,tmp1      ;    
reti                 ;     
REP11:
clr  tmp1
in  tmp1,PINB        ;    SB2
sbrs tmp1,1          ;   ,    
inc  BCD0            ;    PCF8583, UP
clr  tmp1
in  tmp1,PINB        ;    SB3
sbrs tmp1,2          ;   ,    
dec  BCD0            ;    PCF8583, DOWN
cpi  BCD0,0          ;   Timer
breq Sel19
cpi  BCD0,1          ;   Control ( )
breq Sel20
cpi  BCD0,2          ;   Control ( )
breq Sel21

Sel19:
ldi  r28,$0F         ;  AL_Timer
ldi   ZH,high(Text15)
ldi   ZL,low(Text15) ; Z    
rcall OutWHvar       ;    
rjmp  Home3
Sel20:
ldi  r28,$08         ;   Control
ldi  r27,$D2         ;   
ldi   ZH,high(Text21)
ldi   ZL,low(Text21) ; Z    
rcall OutWHvar       ;    
ldi  r27,$D2         ;   
clr BCD2             ;   
rjmp  REP12
Sel21:
ldi  r28,$08         ;  Control
ldi  r27,$D3         ;   
ldi   ZH,high(Text22)
ldi   ZL,low(Text22) ; Z    
rcall OutWHvar       ;    
ldi  r27,$D3         ;   
ldi BCD2,$FF         ;   
rjmp  REP12

Home3:       ;    

clr  tmp1
in  tmp1,PINB        ;    SB4
sbrs tmp1,3          ;   ,    
inc  hexL            ;     PCF8583, UP
clr  tmp1
in  tmp1,PINB        ;    SB5
sbrs tmp1,4          ;   ,    
dec  hexL            ;     PCF8583, DOWN
mov r27,hexL
REP12:
clr  tmp1
in  tmp1,PINB        ;    SB1
sbrs tmp1,0          ;   ,    
rjmp OutWHTim        ;     PCF8583
Return3:
ldi  tmp1,$0C        ;  ,     2
mov  tim3,tmp1
ldi  tmp1,0          ;    2 
out  TCNT2,tmp1
ldi   tmp1,7	     ;  
out   TCCR2,tmp1     ;  T/C2,  . = 1024
ldi  tmp1,(1<<TOIE2)
out  TIMSK,tmp1      ;    
reti                 ;     

OutWHITim:      ;      

wdr
ldi   prm1,$0C	    ;  , .   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   prm1,$01	    ;  ,    
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text25)
ldi   ZL,low(Text25)	; Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
ldi   prm1,$C0	    ;  9-   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text26)
ldi   ZL,low(Text26); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
rcall  Wait1000     ;  1.0 
ret

OutWHTim:      ;     ,  

wdr
ldi   prm1,$0C	    ;  , .   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   prm1,$01	    ;  ,    
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text35)
ldi   ZL,low(Text35); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
ldi   prm1,$C0	    ;  9-   
rcall WaitBusy	    ;   -  
rcall SendCom	    ;  
ldi   ZH,high(Text36)
ldi   ZL,low(Text36); Z    
ldi   Cnt,8         ;    8 
rcall OutText       ;    
rcall  Wait1000     ;  1.0 
rcall WritePCF
rjmp Return3

OutWHCTim:     ;    

wdr
ldi   prm1,$0C	  ;  , .   
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$01	  ;  ,    
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
mov   tmp2,BCD1   ;  BCD1  tmp2
swap  BCD1        ;    
andi  BCD1,$0F    ; 
ori   BCD1,$30    ;    
mov   prm1,BCD1   ;   2
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
mov   BCD1,tmp2   ;  BCD1
andi  BCD1,$0F    ; 
ori   BCD1,$30    ;    
mov   prm1,BCD1   ;   1
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   ZH,high(Text19)
ldi   ZL,low(Text19); Z    
ldi   Cnt,8	        ;    8 
rcall OutText       ;    
ldi   prm1,$C0	  ;  9-   
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   ZH,high(Text20)
ldi   ZL,low(Text20); Z    
ldi   Cnt,8	        ;    8 
rcall OutText       ;    
rcall Wait250
ret

OutWHCTim2:     ;    

ldi   prm1,$0C	  ;  , .   
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$01	  ;  ,    
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
lds   prm1,SV9    ;  prm1
swap  prm1        ;    
andi  prm1,$0F    ; 
ori   prm1,$30    ;    
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
lds   prm1,SV9    ;  prm1
andi  prm1,$0F    ; 
ori   prm1,$30    ;    
rcall WaitBusy	  ;   -  
rcall SendDat     ;  
ldi   ZH,high(Text19)
ldi   ZL,low(Text19); Z    
ldi   Cnt,8	        ;    8 
rcall OutText       ;    
ldi   prm1,$C0	  ;  9-   
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   ZH,high(Text20)
ldi   ZL,low(Text20); Z    
ldi   Cnt,8	        ;    8 
rcall OutText       ;    
rcall Wait1000      ;  3.0 
wdr
rcall Wait1000
wdr
rcall Wait1000
ret

ReadTim:    ;    (Timer)

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait85:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait85

ldi  tmp1,$A0     ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait86:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait86

ldi  tmp1,7
           
out  TWDR,tmp1    ;   TWDR  -
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait87:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait87

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait88:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait88

ldi  tmp1,$A1   ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) 
out  TWCR,tmp1
wait89:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait89
               ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (0<<TWEA)
out  TWCR,tmp1
wait90:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait90
in   BCD1,TWDR
sts SV9,BCD1  ;        
                          
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret

ALARMTimer:         ;   

wdr
ldi tmp1,0          ;      
out TIMSK,tmp1
ldi tmp1,$07
mov Stime,tmp1      ;   
AL:
rcall OutWHAL       ;   "ALARM"  LCD
ldi  I1,255         ;   ,  
                    ;             
REP13:
wdr
cbi PortB,5         ;   
nop
sbi DDRB,5          ;   
rcall Wait05ms      
cbi DDRB,5          
rcall Wait05ms 
dec  I1
cpi  I1,0
breq REP14     
rjmp REP13
REP14:
rcall Wait250       ;   
rcall Wait250
dec Stime           ;     
mov I1,Stime
cpi I1,0            ;   0
breq REP15          ; ,  0
rjmp AL
REP15:
ldi r29,$A0         ;   
ldi r28,0
lds r27,0           ;            
rcall WritePCF
ldi r29,$A0         ;    
ldi r28,0
lds r27,SV2         ;      
                    ;   
rcall WritePCF
ldi r29,$A0         ;   Control
ldi r28,$08
lds r27,SV7         ;    
rcall WritePCF
ldi r29,$A0
ldi r28,7
ldi r27,0
rcall WritePCF
ldi r29,$A0          ;   AL_Timer
ldi r28,$0F
lds r27,SV6          ;    
rcall WritePCF
ldi tmp1,$1E
mov Stime,tmp1       ;                                             
rjmp  OutWHBM        ;     

StopTim:        ;   

rcall OutWH5
ldi r29,$A0         ;   
ldi r28,0
lds r27,0           ;            
rcall WritePCF
ldi r29,$A0         ;    
ldi r28,0
lds r27,SV2         ;      
                    ;   
rcall WritePCF
ldi r29,$A0         ;   Control
ldi r28,$08
lds r27,SV7         ;    
rcall WritePCF
ldi r29,$A0
ldi r28,7
ldi r27,0
rcall WritePCF
ldi r29,$A0          ;   AL_Timer
ldi r28,$0F
lds r27,SV6          ;    
rcall WritePCF
ldi tmp1,$1E
mov Stime,tmp1       ;    
rcall OutWHCTim2     ;                                             
rjmp  OutWHBM        ;     

OutWHWork:     ;       

wdr
ldi   prm1,$0C	  ;  , .   
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   prm1,$01	  ;  ,    
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   ZH,high(Text27)
ldi   ZL,low(Text27); Z    
ldi   Cnt,8	        ;    8 
rcall OutText       ;    
ldi   prm1,$C0	  ;  9-   
rcall WaitBusy	  ;   -  
rcall SendCom	  ;  
ldi   ZH,high(Text28)
ldi   ZL,low(Text28); Z    
ldi   Cnt,8	        ;    8 
rcall OutText       ;    
rcall Wait1000
ret

ReadPCFC:    ;    (Control)

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait91:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait91

ldi  tmp1,$A0     ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait92:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait92

ldi  tmp1,8
           
out  TWDR,tmp1    ;   TWDR  -
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait93:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait93

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait94:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait94

ldi  tmp1,$A1   ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) 
out  TWCR,tmp1
wait95:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait95
               ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (0<<TWEA)
out  TWCR,tmp1
wait96:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait96
in   BCD1,TWDR
sts SV7,BCD1  ;      
                           
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret

ReadPCFA:    ;    (AL_Timer)

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait97:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait97

ldi  tmp1,$A0     ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait98:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait98

ldi  tmp1,$0F
           
out  TWDR,tmp1    ;   TWDR  -
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait99:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait99

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait100:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait100

ldi  tmp1,$A1   ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) 
out  TWCR,tmp1
wait101:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait101
               ;   
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (0<<TWEA)
out  TWCR,tmp1
wait102:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait102
in   BCD1,TWDR
sts SV6,BCD1   ;      
                          
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret

ReadPCFSec:    ;    (second)

wdr
ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait103:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait103

ldi  tmp1,$A0     ;   TWDR   
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait104:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait104

ldi  tmp1,$02
           
out  TWDR,tmp1    ;   TWDR  -
ldi  tmp1, (1<<TWINT) | (1<<TWEN)
out  TWCR,tmp1
wait105:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait105

ldi  tmp1,(1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (0<<TWSTO)
out  TWCR,tmp1  ;     
wait106:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait106

ldi  tmp1,$A1   ;   TWDR   , 
out  TWDR,tmp1
ldi  tmp1, (1<<TWINT) | (1<<TWEN) 
out  TWCR,tmp1
wait107:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait107
               ;    ()
ldi  tmp1, (1<<TWINT) | (1<<TWEN) |  (0<<TWEA)
out  TWCR,tmp1
wait108:
in   tmp1,TWCR
sbrs tmp1,TWINT
rjmp wait108
in   BCD1,TWDR
                          
ldi  tmp1, (1<<TWINT) | (1<<TWEN) | (1<<TWSTO)  ; 
out  TWCR,tmp1
ret

EEWrite:		;  "  EEPROM"

    cli                 ;  
	sbic	EECR,EEWE	;  EEWE  . 0, 
	rjmp	EEWrite		;    
    ldi tmp2,0          ;      EEPROM -
	out	EEARH,tmp2 	    ;     
		                ;      EEPROM -
	out	EEARL,m1 	    ;     
	out	EEDR,tmp1	    ;   -    
	sbi	EECR,EEMWE	    ;  EEMWE  
	sbi	EECR,EEWE	    ;  EEWE :  
				        ;     4- ,  
			        	;     2 
    sei                 ;  
	ret

EERead:			;  " EEPROM"

    cli                 ;  
	sbic	EECR, EEWE	;  EEWE  . 0, 
	rjmp	EERead		;    
    ldi tmp2,0          ;      EEPROM -
	out	EEARH,tmp2 	    ;     
	           	        ;     EEPROM -
	out	EEARL,m1	    ;      
	sbi	EECR, EERE	    ;   EERE    .
				        ;   4 ,  
				        ;   2 
	in	tmp1, EEDR	    ;   
    sei                 ;  
	ret
             ;  RAM
.dseg
  
SV0: .byte 1   ;  ,  
SV1: .byte 1   ;  ,  
SV2: .byte 1   ;   STATUS
SV3: .byte 1   ;        
SV4: .byte 1   ;  Weekday/Month
SV5: .byte 1   ;   
SV6: .byte 1   ;   AL_Timer
SV7: .byte 1   ;   ALARM CONTROL 
SV8: .byte 1   ;      
SV9: .byte 1   ;       
SV10: .byte 1  ;   (T-N) ,  
SV11: .byte 1  ;   (T-N) ,   
SV12: .byte 1  ;  

 ; END -   




